Closed Bug 1461203 Opened 3 years ago Closed 3 years ago

[Ubuntu 16.04] Arrows on scrollbars are not visible; also sometimes there are empty scrollbars

Categories

(Core :: Widget: Gtk, defect)

60 Branch
x86_64
Linux
defect
Not set
normal

Tracking

()

VERIFIED FIXED
mozilla62
Tracking Status
firefox-esr52 --- unaffected
firefox-esr60 61+ verified
firefox60 - wontfix
firefox61 + verified
firefox62 + verified

People

(Reporter: sniffnoy, Assigned: stransky)

References

Details

(Keywords: regression)

Attachments

(3 files)

User Agent: Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:60.0) Gecko/20100101 Firefox/60.0
Build ID: 20180510203301

Steps to reproduce:

Open any page with scroll bars.  This applies to both the scroll bars on the window itself and to scroll bars on page components (as seen in the attached screenshot).  It also applies to horizontal scroll bars, not just vertical ones.

As an example, one may open https://www.mozilla.org/en-GB/ and observe the behavior.  If for some reason scroll bars do not appear, one may shrink the window until they do and observe the behavior.

https://bugzilla.mozilla.org/query.cgi is an example that shows the behavior with in-page scrollbars, and also shows the "empty scroll bar" behavior mentioned below.  One may also shrink the page window to observe the behavior with horizontal scrollbars.

The version of Firefox is 60.0 (64-bit) running on Linux Mint 18.3.


Actual results:

The arrows on the ends of the scroll bar are not visible; instead they look like just an area of empty scroll bar space.  Note that the arrows are still *there* -- the scroll bar itself will not scroll into the area where the arrows are, and clicking on the arrows still works.  However, they are not displayed.  (For instance, in the attached screenshot, all scrolling areas shown are scrolled all the way up.)

In addition, sometimes a page may display a completely empty scroll bar when no scroll bar at all is needed.


Expected results:

The scroll bar arrows should be displayed.  Also, if there is no need for a scroll bar, none should be displayed, rather than an empty one.
Has STR: --- → yes
Component: Untriaged → Widget: Gtk
OS: Unspecified → Linux
Product: Firefox → Core
Hardware: Unspecified → x86_64
Can confirm exactly this same behavior on the Firefox 60 version shipped with Ubuntu 14.04 LTS.

Example: https://i.imgur.com/riYER79.png
Duplicate of this bug: 1461223
I can't test this myself, but I'm confirming it because it's been reported by 3 people.

It would be helpful if one of you could find the regression range.
https://mozilla.github.io/mozregression/quickstart.html
Status: UNCONFIRMED → NEW
Has Regression Range: --- → no
Ever confirmed: true
I haven't been able to get mozregression to work, unfortunately.  Not sure whether I should put the error message here as that's kind of off-topic?
(In reply to Harry Altman from comment #4)
> I haven't been able to get mozregression to work, unfortunately.  Not sure
> whether I should put the error message here as that's kind of off-topic?

Advanced search lets you search for that error message in bug comments.
https://bugzilla.mozilla.org/query.cgi?format=advanced

If there are no reports for that issue, you can file a new one in Testing :: mozregression
https://bugzilla.mozilla.org/enter_bug.cgi?product=Testing
Duplicate of this bug: 1461312
For me, mozregression converges differently depending on how I specify the initial interval.

Last time I did ‘mozregression --good 60’, it converged to a list of three commits, all pointing at Bug 1355143 (which deals with scroll bars and so is under suspicion).

When I do it now, it points to Bug 1452536 instead (but it doesn’t make sense to me):

34:43.54 INFO: Last good revision: 4252c770699c81f0da958cafc313a37a9a4ac1ae
34:43.54 INFO: First bad revision: 1259c5bc20a733a19d343819d6d88c61445ec86f
34:43.54 INFO: Pushlog:
https://hg.mozilla.org/integration/autoland/pushloghtml?fromchange=4252c770699c81f0da958cafc313a37a9a4ac1ae&tochange=1259c5bc20a733a19d343819d6d88c61445ec86f

I can arrive at the same pushlog as previously if I do ‘mozregression --good 60 --bad 2018-04-25’:

 8:43.63 INFO: Last good revision: 16bb3f3c01cbaf2ec6990cb4499dfbe096d994fc
 8:43.63 INFO: First bad revision: 4405d1c4673b0b1eb415b528c5e252585094b150
 8:43.63 INFO: Pushlog:
https://hg.mozilla.org/integration/autoland/pushloghtml?fromchange=16bb3f3c01cbaf2ec6990cb4499dfbe096d994fc&tochange=4405d1c4673b0b1eb415b528c5e252585094b150

The last ‘inbound’ interval is:

https://hg.mozilla.org/mozilla-central/pushloghtml?fromchange=8ed49dd81059dfdd876cf62ad5def1cfa56ffbbf&tochange=5c983ad5a421edc1d56179d437c7397191ef47d5

The last ‘nightly’ interval is:

https://hg.mozilla.org/mozilla-central/pushloghtml?fromchange=a0c804993efc599a95e97bea39fa1528fd0195d8&tochange=5d73549d363f2a52854ff43fabac9c6fd05b90b0

I will try reverting Bug 1355143 commits and see where that goes.
Assignee: nobody → stransky
Summary: Arrows on scrollbars are not visible; also sometimes there are empty scrollbars → [Ubuntu 16.04] Arrows on scrollbars are not visible; also sometimes there are empty scrollbars
Hello,

The last good build found is v40.0.3 and the first bad version found is v50.0.2
Attempting to run mozregression with "mozregression --good 2015-03-30 --bad 2016-06-06"  will result in a impossibility to finish bisection due to missing build in this interval.
I can confirm this. Firefox 59.0.3 - scrollbar buttons are visible. Firefox 60 and up - invisible.
Here is the screenshot: http://0x0.st/seug.png
Sorry, P.S: Debian 8 32bit, MATE 1.8.2. Theme (Controls): Clearlooks Phenix. As it turns out the theme doesn't affect this issue.
Yes I can reproduce that on Ubuntu 16.04/trunk/Clearlooks Phenix. Looks like some late/wrong inactive scrollbar metrics resolution, when the scrollbar is selected/focused the buttons are drawn.
> Yes I can reproduce that on Ubuntu 16.04/trunk/Clearlooks Phenix

Do you also see this with another theme?

> when the scrollbar is selected/focused the buttons are drawn

Sorry, but how can you focus a scrollbar? I want to try it too.
Comment on attachment 8976508 [details]
Bug 1461203 - use GetScrollbarMetrics() to access scrollbar metrics,

https://reviewboard.mozilla.org/r/244628/#review250676
Attachment #8976508 - Flags: review?(jhorak) → review+
Pushed by stransky@redhat.com:
https://hg.mozilla.org/integration/autoland/rev/bdfce06ecdb4
use GetScrollbarMetrics() to access scrollbar metrics, r=jhorak
[Tracking Requested - why for this release]:
Would be great to uplift to 61 / ESR60.
https://hg.mozilla.org/mozilla-central/rev/bdfce06ecdb4
Status: NEW → RESOLVED
Closed: 3 years ago
Resolution: --- → FIXED
Target Milestone: --- → mozilla62
Eww. Let's keep this on the radar for a possible Fx60 dot release ride-along candidate as well. Please go ahead and nominate for Beta approval when you get a chance.
Harry (and others) can you please confirm the fix in latest nightly? Thanks.
Flags: needinfo?(sniffnoy)
I confirm the fix. Thanks!
(In reply to TheExplorer from comment #21)
> I confirm the fix. Thanks!

The nightly for 2018-05-18 has not yet been built. Can you please list the version on which you have verified the fix? (I can still reproduce this on 62.01a (2018-05-17).
Flags: needinfo?(alex.satellite)
Mine 62.0a1 (2018-05-17) (32-bit) is OK here. The arrows and the buttons on the right scrollbar are back.
Flags: needinfo?(alex.satellite)
Hi Martin, 

I have retested this issue and these are my results:

- Windows 10 and latest Nightly (05/18/2018) - empty scrollbars are being displayed.
- Ubuntu 16.04 and latest Nightly (05/18/2018) - empty scrollbars are being displayed and arrows on scrollbars are not visible.
- Ubuntu 17.04 and latest Nightly (05/18/2018) - arrows on scrollbars are not visible.

Firstly, the fact that the arrows are not being displayed on scrollbars seems like intended design in Ubuntu. Am I right?
If yes, that would mean that the issue is fixed in the latest Nightly but only for Ubuntu 17.o4 LTS 64-bit, and not fixed for Ubuntu 16.04 LTS 64-bit and Windows 10 46-bit.

Secondly, does the fix cover the fact that empty scrollbars are displayed? Or does it cover the fact that arrows are not displayed in the scrollbars in Ubuntu? Or should it fix both?

Thanks!
Flags: needinfo?(stransky)
(In reply to Bodea Daniel from comment #24)
> Hi Martin, 
> 
> I have retested this issue and these are my results:
> 
> - Windows 10 and latest Nightly (05/18/2018) - empty scrollbars are being
> displayed.

This is Linux only bug, no Windows is involved here.

> - Ubuntu 16.04 and latest Nightly (05/18/2018) - empty scrollbars are being
> displayed and arrows on scrollbars are not visible.

Interesting, which Gtk+ theme do you use? The default one (Ambiance)?

> - Ubuntu 17.04 and latest Nightly (05/18/2018) - arrows on scrollbars are
> not visible.
> 
> Firstly, the fact that the arrows are not being displayed on scrollbars
> seems like intended design in Ubuntu. Am I right?

It depends on your actual theme - some themes does have the buttons and someone does not (like the default one).

> If yes, that would mean that the issue is fixed in the latest Nightly but
> only for Ubuntu 17.o4 LTS 64-bit, and not fixed for Ubuntu 16.04 LTS 64-bit
> and Windows 10 46-bit.
> 
> Secondly, does the fix cover the fact that empty scrollbars are displayed?
> Or does it cover the fact that arrows are not displayed in the scrollbars in
> Ubuntu? Or should it fix both?

This patch covers only a missing buttons....I'm not aware of missing scrollbars or so.
Flags: needinfo?(stransky)
(In reply to Martin Stránský [:stransky] from comment #20)
> Harry (and others) can you please confirm the fix in latest nightly? Thanks.

Not latest nightly, sorry, but I just updated to 60.0.1 and the problem is still occurring.

Since people are mentioning theme as potentially relevant, I'll mention that I'm using the Clearlooks-Phénix theme.
Flags: needinfo?(sniffnoy)
Comment on attachment 8976508 [details]
Bug 1461203 - use GetScrollbarMetrics() to access scrollbar metrics,

Approval Request Comment
[Feature/Bug causing the regression]: Bug 1355143 
[User impact if declined]: invisible scrollbar buttons
[Is this code covered by automated tests?]: no
[Has the fix been verified in Nightly?]: yes
[Needs manual test from QE? If yes, steps to reproduce]: yes, install Clearlooks Phenix theme and check of the scrollbar buttons are visible.
[List of other uplifts needed for the feature/fix]: none
[Is the change risky?]: no
[Why is the change risky/not risky?]: minor theme fix on Linux/Gtk+.
[String changes made/needed]: none
Attachment #8976508 - Flags: approval-mozilla-beta?
Comment on attachment 8976508 [details]
Bug 1461203 - use GetScrollbarMetrics() to access scrollbar metrics,

[Approval Request Comment]
If this is not a sec:{high,crit} bug, please state case for ESR consideration:
User impact if declined: Major UI regression on Ubuntu 16.04
Fix Landed on Version: 62.0
Risk to taking this patch (and alternatives if risky): small theme fix on Linux/Gtk+.
String or UUID changes made by this patch: none

See https://wiki.mozilla.org/Release_Management/ESR_Landing_Process for more info.
Attachment #8976508 - Flags: approval-mozilla-esr60?
Comment on attachment 8976508 [details]
Bug 1461203 - use GetScrollbarMetrics() to access scrollbar metrics,

Sounds like we've gotten enough confirmation from Nightly testers to feel good about uplifting. Let's uplift this to Beta for 61.0b7 also.
Attachment #8976508 - Flags: approval-mozilla-beta? → approval-mozilla-beta+
(In reply to Martin Stránský [:stransky] from comment #25)
> (In reply to Bodea Daniel from comment #24)

> > - Ubuntu 16.04 and latest Nightly (05/18/2018) - empty scrollbars are being
> > displayed and arrows on scrollbars are not visible.
> 
> Interesting, which Gtk+ theme do you use? The default one (Ambiance)?
> 
Both the Ubuntu 16 and 17 have the same Ambiance (Default) theme and yes, the empty scrollbars are still displayed in 16 and not in 17.

> > - Ubuntu 17.04 and latest Nightly (05/18/2018) - arrows on scrollbars are
> > not visible.
> > 
> > Firstly, the fact that the arrows are not being displayed on scrollbars
> > seems like intended design in Ubuntu. Am I right?
> 
> It depends on your actual theme - some themes does have the buttons and
> someone does not (like the default one).
> 
I am using the default theme (Ambience) on both machines and the scroll buttons aren't displayed on neither of them. Nevertheless, this seems intended.

> > If yes, that would mean that the issue is fixed in the latest Nightly but
> > only for Ubuntu 17.o4 LTS 64-bit, and not fixed for Ubuntu 16.04 LTS 64-bit
> > and Windows 10 46-bit.
> > 
> > Secondly, does the fix cover the fact that empty scrollbars are displayed?
> > Or does it cover the fact that arrow buttons are not displayed in the scrollbars in
> > Ubuntu? Or should it fix both?
> 
> This patch covers only a missing buttons....I'm not aware of missing
> scrollbars or so.
The other issue mentioned in the title is that empty (unnecessary) scrollbars are being displayed.

Martin Stránský, I have tested again using the Clearlooks Pheonix Theme and the latest Nightly (v62.0a1) these are my results:
- Ubuntu 16.04 LTS 64-bit: buttons from scrollbar are displayed (and empty scrollbars are being displayed)
- Ubuntu 17.04 LTS 64-bit: buttons from scrollbar are displayed (and empty scrollbars are being displayed)

Considering that I cannot reproduce the issue on an older Firefox version and on this theme, I will have to ask the reporter to validate your fix in the latest Nightly.
Updated by mistake. Change reverted.
Hello Harry Altman,

Considering the fact that the issue could not be reproduced on my test machines, I have to ask you to check the fix.

Please download Firefox Nightly from here: https://nightly.mozilla.org/ and retest the problem.

Your fix will reach the release version in a while, but we need to validate it in the trunk version, Firefox Nightly v62.
Tomorrow evening it can also be validated in Firefox Beta v61 so it can be uplifted (to reach the release version faster.

Thank you for your contribution!
Flags: needinfo?(sniffnoy)
If by empty scrollbars you mean the one on the right of the main section of https://bugzilla.mozilla.org/query.cgi , then that is explicitly requested by the “overflow-y: scroll” CSS rule on that page.
Running latest nightly on Ubuntu 14.04, XFCE, Radiance theme. Scrollbar arrows are back in place.
Sorry, Raleigh theme, not Radiance.
Comment on attachment 8976508 [details]
Bug 1461203 - use GetScrollbarMetrics() to access scrollbar metrics,

gtk fix for 60.1esr
Attachment #8976508 - Flags: approval-mozilla-esr60? → approval-mozilla-esr60+
(In reply to Ryan VanderMeulen [:RyanVM] from comment #38)
> https://hg.mozilla.org/releases/mozilla-esr60/rev/efd762c4f413

Oh, nice to see such quick progress! Thanks!

P.S. Hello, Ryan! I used to be a fan of your WinXP update packs! Didn't think I would meet you here :)
(In reply to TheExplorer from comment #39)
> P.S. Hello, Ryan! I used to be a fan of your WinXP update packs! Didn't
> think I would meet you here :)

*waves* :-)
I could finally reproduce the bug with Clearlooks-Phenix controls installed properly on the unfixed Firefox version, Release v60.0.2.
I can validate the fix in Beta v61.0b12 and Nightly v62.0a1, but unfortunately, this issue still occurs on 60ESR (v60.0.2ESR)!

@Martin, do you know why this has happened?
Flags: needinfo?(stransky)
This fix isn't in the ESR 60.0.2 release, it's due to ship with 60.1. You need to test with a current CI build from that branch if you want to verify the fix now.
Flags: needinfo?(stransky) → needinfo?(daniel.bodea)
Thank you, Ryan. I can now validate this fix using CI build from here:
https://treeherder.mozilla.org/#/jobs?repo=mozilla-esr60&revision=5a7eef7de073ad8b0405ee3903290f617eda10eb


Bug validated.
Status: RESOLVED → VERIFIED
Flags: needinfo?(daniel.bodea)
Clearing unnecessary information request. 
Also, removing the qe-verify+ tag, since this issue is verified in all necessary versions.
Flags: qe-verify+
Flags: needinfo?(sniffnoy)
You need to log in before you can comment on or make changes to this bug.